#include <iostream>
#include <vector>

#include <sys/time.h>

#include "CIoInitiator.h"
#include "IoCreator.h"
#include "statitics.h"


using namespace std;

CIoInitiatorFactory f;


void usage()
{
    printf("usage is:\n\t -p<parent dir>\n\t -s<stream size>\n\t -b<buffer size>\n\t -i<start index>\n\t -n<no. streams> \n\t-r[reverse]\n");
}

int validate_args(){


 if  ( Streams<=0 ){
	 printf("Streams no. %d is not valid\n",Streams);
	 return -1;
 }
   
  if ( StreamSizeMB==0  || StreamSizeMB >= 100000 ){
	  printf("Stream Size  %d is not valid\n",StreamSizeMB);
	  return -1;		
 }

  if (  BufferSizeKB==0  ||  BufferSizeKB >= 104857600 ){
	  printf("Buffer Size  %d is not valid\n",BufferSizeKB);
	  return -1;		
 }
  return 0;
}



int main (int argc, char *argv[])
{

	int i = 1 ;
	string dirName;

	if ( take_options(argc,argv,dirName) < 0 || validate_args() < 0 ){

		usage();
		return -1;
	}

	for (i=0;i<Streams;i++){

		CIoInitiator* o =f.Create(BufferSizeKB<<10,0);
		io.push_back(o);
	}

	if(open_files(dirName)<0){
		return -1;
	}

	printf( "\tSize of Buffer %d KB\n\t" , BufferSizeKB );
	printf( "Size of Stream %d MB\n\t" , StreamSizeMB);
	printf( "Number Of Streams %d\n\t" , Streams ) ;
	
	if (bReverse) {
		printf( "files in reverse manner\n\t",startIndex,dirName.c_str());
	}else
		printf( "Staring Index  %d in %s\n\t",startIndex,dirName.c_str());

	unsigned long long totBytes = (unsigned long long)(StreamSizeMB<<20) *(unsigned long long)Streams ;
	
	list<CIoInitiator*>::iterator iter;

	gettimeofday(&ts,NULL);
	// new read up to end
	while(curReadBytes<totBytes){
		
		for (iter=io.begin();iter!=io.end();++iter){
		
			CIoInitiator* o = *iter;
			int bytes = o->act();
			if(bytes<0){
				printf("failed to read(%s) \n",o->name().c_str());
				perror("");
				return -1;
			}
			curReadBytes+=bytes;
		}
	}


	gettimeofday(&te,NULL);
	
	statistics();

	return(0);
}

