#include <iostream>
#include <vector>
#include <asm/types.h>
#include <sys/time.h>

#include "CIoInitiator.h"
#include "IoCreator.h"


using namespace std;

CIoInitiatorFactory f;

#define NR_ARGS 5

int main (int argc, char *argv[])
{
	if (argc<NR_ARGS+1) {

		cout << "usage :\t io_test \n\t<File Name Prefix> \n" << 
			    "\t<Size of Buffer in MB>\n" <<
			    "\t<SizeOf of Stream in MB>\n" << 
			    "\t<Number Of Streams>" << endl << 
				"\t<r/w>" << endl;
		return -1;
	}

	int i = 1 ;

	string fileName(argv[i++]);
	int BufferSizeMB = atoi(argv[i++]);
	int StreamSizeMB  = atoi(argv[i++]);
	int Streams   = atoi(argv[i++]);
	if (!strcmp(argv[i++],"w")) {
		f.set_io_type(WRITE);
	}


	// now create the readers
	vector<CIoInitiator*> ios;
   

	for (i=0;i<Streams;i++){

		CIoInitiator* o =f.Create(BufferSizeMB<<20,0);
		ios.push_back(o);
	}

	// now initiates a sequential reads all over the disk
	//vector<CIoInitiator*>::iterator ReadIter=Readers.begin();
	for (i = 0; i< Streams;i++){

		CIoInitiator* o = ios[i];
		char fname[256];
		sprintf(fname,"%s%d",fileName.c_str(),i);
		string name(fname);

		if(!o->open(name,1)){
			printf("error : failed to open %s\n",name.c_str());
			return -1;
		}
	}

	__u64 curReadBytes=0;
	__u64 totBytes = (__u64)( (StreamSizeMB * Streams) << 20);
	struct timeval te,ts;

	gettimeofday(&ts,NULL);
	// new read up to end
	while(curReadBytes<totBytes){

		for (i = 0; i< Streams;i++) {

			CIoInitiator* io = ios[i];
			if(!io->act()){
				perror("failed to read:");
				return -1;
			}
		}
		curReadBytes+=(BufferSizeMB<<20)*Streams;
	}

	gettimeofday(&te,NULL);

	float delta_ms = (te.tv_sec-ts.tv_sec)*1000 + (te.tv_usec-ts.tv_usec)/1000;

	printf("MBytes/secs \n%f\n",((curReadBytes>>20)/delta_ms)*1000);
	
	return(0);
}

