#include <iostream>
#include <vector>

#include <sys/time.h>
#include <semaphore.h>

using namespace std;

#include "CIoInitiator.h"
#include "IoCreator.h"
#include "statitics.h"

#define NR_ARGS 5


sem_t reader_sem;



void* IoThread(void* d){

	CIoInitiator* io = (CIoInitiator*)d;

	
	unsigned long long totBytes    = (unsigned long long)(StreamSizeMB) << 20 ;
	unsigned long long ReadBytes = 0;
	
	while(ReadBytes<totBytes){

	  int bytes = io->act();
 	  if(bytes<0){
				 perror("");
				 return 0;
		}		 
		ReadBytes+=bytes;
	}

	sem_post(&reader_sem);
    
	return 0;
}

CIoInitiatorFactory f;

void usage()
{
    printf("usage is:\n\t -p<parent dir>\n\t -s<stream size>\n\t -b<buffer size>\n\t -i<start index>\n\t -n<no. streams>\n");
}

int validate_args(){


 if  ( Streams<=0 ){
	 printf("Streams no. %d is not valid\n",Streams);
	 return -1;
 }
   
  if ( StreamSizeMB==0  || StreamSizeMB >= 100000 ){
	  printf("Stream Size  %d is not valid\n",StreamSizeMB);
	  return -1;		
 }

  if (  BufferSizeKB==0  ||  BufferSizeKB >= 104857600 ){
	  printf("Buffer Size  %d is not valid\n",BufferSizeKB);
	  return -1;		
 }
  return 0;
}

int main (int argc, char *argv[])
{

	string dirName;

	if ( take_options(argc,argv,dirName) < 0 || validate_args() < 0 ){

		usage();
		return -1;
	}


	int i;
	for (i=0;i<Streams;i++){

		CIoInitiator* o = f.Create(BufferSizeKB<<10,0);
		io.push_back(o);
	}


	if (open_files(dirName)<0) {
		return -1;
	}


	printf( "\tSize of Buffer %d KB\n\t" , BufferSizeKB );
	printf( "Size of Stream %d MB\n\t" , StreamSizeMB);
	printf( "Number Of Streams %d\n\t" , Streams ) ;
	printf( "Staring Index  %d in %s\n\t",startIndex,dirName.c_str());

	


	//
	//	now startof the io threads
	// 
	sem_init(&reader_sem,0,0);


	pthread_t t;

	printf("Press any key to start test...");
	getchar();
	gettimeofday(&ts,NULL);
	list<CIoInitiator*>::iterator iter;
	for (iter=io.begin();iter!=io.end();++iter){

		if ( pthread_create(&t,0,IoThread, *iter ) != 0 ) {
			perror("failed to create thread:");
			return -1;
		}
	}
	
	for(int i =0 ; i < Streams ; i++)
		sem_wait(&reader_sem);

	gettimeofday(&te,NULL);

	curReadBytes  = (((unsigned long long )StreamSizeMB)<<20) * Streams;
	statistics();
	return(0);
}

