
#include "AsyncSpooler.h"
#include "AsyncReader.h"

extern int Streams;
extern unsigned long long BufferSizeKB;
extern unsigned long long curReadBytes;

//   
//  Main io spooler wait on and io 
//	when an io event is done we take the AsyncIoReader
//  from the private area and invoke the act strategy 
//

int CasyncIoSpooler::Run(){


	while(totBytesToRead){

	int nr = io_getevents(ctxp,1,Streams,events,0);

    for (int i = 0 ; i < nr ; i++) {
        struct io_event *event = events + i;
        CIoInitiator * io = (CIoInitiator *)(event->data);
		int bytes = io->act();
		if ( bytes<0 ){
					perror("Run :");
					return -1;
				}
			totBytesToRead -= bytes;
			curReadBytes+=bytes;
		}
	}
}




bool CasyncIoSpooler::SubmitIO(CIoInitiator* o){

	CasyncReader * r = (CasyncReader *)o;
	r->startTS(); // get time stamp
	iocb* cb = r->getIoCB();
    cb->data = (void*)r;
	return ( io_submit(ctxp,1,&cb)==1);
}




CasyncIoSpooler::CasyncIoSpooler(unsigned long long t)
{

	totBytesToRead=t;
	int ret = io_setup(Streams,&ctxp);

	if (ret!=0) {
		perror("CasyncIoSpooler");
		throw 0;
	}

	events = new io_event[Streams];

	
}



