#ifndef _CIOINITIATOR_H_
#define _CIOINITIATOR_H_

#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <sys/time.h>


#ifndef  O_LARGEFILE
#define O_LARGEFILE 0
#endif


using namespace std;

typedef enum {
	READ,
	WRITE,
	ASYNC_READ
}IoType;

int open_files(string& fileName);


using namespace std;

class CIoInitiator{

protected:

	int fd; // file descriptor
	int bufferSize;
	char* buffer;
	unsigned long long  curpos; // current position
	string filename;

	struct timeval ts; 
	struct timeval te;
	int  max_delta_ms; 


public:

	CIoInitiator(int bufferSizeBytes,unsigned long long offset=0){

		bufferSize = bufferSizeBytes;
		buffer = (char*)valloc(bufferSize);
		memset(buffer,0x00,bufferSize); // must do that in order to instansiate the buffer
		curpos = offset;
		memset(&ts,0x00,sizeof(ts));
		memset(&te,0x00,sizeof(te));
		fd=0;
	}
	string& name() {return filename;}
    // This function is required for built-in STL list functions like sort
	virtual int CIoInitiator::operator<(const CIoInitiator &rhs) const{
			if( this->curpos < rhs.curpos) return 1;
			return 0;
	}

	// to find by curpos
	virtual int  CIoInitiator::operator ==(const CIoInitiator &rhs) const{		
			if (this->curpos == rhs.curpos) return 1;
			return 0;
	}
	
	void startTS(){gettimeofday(&this->ts,0);}
	void endTS()  { 
		gettimeofday(&this->te,0);
		int cur_delta=(this->te.tv_sec-this->ts.tv_sec)*1000 + (this->te.tv_usec-this->ts.tv_usec)/1000;
		if ( cur_delta > max_delta_ms)
			max_delta_ms = cur_delta;
	 }

	int  getMaxDurationMS() { return max_delta_ms;}

	unsigned long long	getCurpos(){return curpos;}	
	virtual int act() {return -1;} ;
	virtual bool open(const string &fname,int noBuffered) {return false;}
	
};

#endif


