
#include <iostream>
#include <vector>
#include "CIoInitiator.h"
       #include <stdio.h>     /* for printf */
       #include <stdlib.h>    /* for exit */
       #include <getopt.h>

using namespace std;
#include "statitics.h"

int Streams=0;
int startIndex=0;
unsigned long long StreamSizeMB=0;
unsigned long long BufferSizeKB=0;
unsigned long long curReadBytes=0;
unsigned long long diskSizeBytesMB;
bool bSort=true;
bool bReverse=false;

struct option long_options[] = {
		
		{"b", 1, 0, 0},  // size of buffer 
		{"?", 0, 0, 0},  // usage
		{"s", 0, 0, 0},  // size of stream
		{"n", 1, 0, 0},  // number of initiators
		{"d", 1, 0, 0},  //  size of disk
		{"p", 1, 0, 0},  // prefix name
		{"i", 1, 0, 0}, // start index
		{"r", 0, 0, 0}, // start index
		{"x", 0, 0, 0}, // start index
		{ 0, 0, 0, 0}
	};

struct timeval ts;
struct timeval te;
// now create the io
list<CIoInitiator*> io;

void   statistics(){


	float delta_sec= (te.tv_sec-ts.tv_sec) + ((te.tv_usec - ts.tv_usec)%1000000)/1000000.0;
	int totMB =  (curReadBytes>>20);
	int max=0,sum=0;

	list<CIoInitiator*>::iterator iter;
	for (iter=io.begin();iter!=io.end();++iter){

		CIoInitiator* o = *iter;
		sum += o->getMaxDurationMS(); // sum avg max from all sessions
		if (o->getMaxDurationMS()>max) {
			max = o->getMaxDurationMS();
		}
	}

	printf("\nTotal MB(in MB) :%d\nTot Time %f\n",totMB,delta_sec);
	printf("MBytes/secs %f\n", totMB  /delta_sec );
	printf("Maximum IO duration %d ms\n",max);
	printf("Average IO duration %d ms\n",sum/Streams);
}


void StatInfo(){
	
	printf( "Size of Buffer %d KB\n" , BufferSizeKB );
	printf( "Size of Stream %d MB\n" , StreamSizeMB);
	printf( "Number Of Streams %d\n" , Streams ) ;
}

	

int take_options(int argc, char *argv[],string& dirName){

	
	while(1){
	int option_index = 0;
	int c = getopt_long (argc, argv, "p:s:b:d:i:n:rx?:",
			 long_options, &option_index);
	if (c == -1)
		break;

	switch (c) {

	case 'p': // dir name name
		  dirName = string(optarg);
		break;

	case 's':
			StreamSizeMB  =   atoi(optarg);
			break;

	case 'b':
		     BufferSizeKB  =   1024*( atof(optarg) );
			 break;

	case 'd':
			 diskSizeBytesMB = (unsigned long long)atoi(optarg) << 10;
		break;

	case 'i':
			startIndex  = atoi(optarg);
		break;

	case 'n':
		  Streams   = atoi(optarg); 
		break;

	case 'r':
			bReverse=true;
			break;
	case 'x': // do not sort positions for raw disk
			bSort=false;
		break;

	case '?':
			return -1;
		break;
	 }
	option_index++;
	}
	return 0;
}


